commands.add_command("give-start-items", "Give power armor and bots (once per player)", function() 
    if global.used == nil then
        global.used = {}
    end
    local player = game.player
    if global.used and global.used[player.name] then 
        game.player.print("You are only allowed to use this once");
        return
    end
    if not player.get_inventory(defines.inventory.player_armor).is_empty() then
        game.player.print("Armor is equipped - please remove")
        return
    end
    player.insert{name="power-armor", count = 1}
    local p_armor = player.get_inventory(defines.inventory.player_armor)[1].grid
    p_armor.put{name = "fusion-reactor-equipment"}
    p_armor.put{name = "personal-roboport-equipment"}
    p_armor.put{name = "battery-mk2-equipment"}
    p_armor.put{name = "personal-roboport-equipment"}
    player.insert{name="construction-robot", count = 20}
    global.used[player.name] = true
end)

commands.add_command("do-the-thing", "Reduce evolution to manageable value", function() 
    game.map_settings.enemy_evolution = {
        enabled=true,
        time_factor = 0,
        destroy_factor = 0.0,
        pollution_factor = 0.00003
    }
    
    game.map_settings.pollution.ageing = 1
    game.map_settings.enemy_expansion.settler_group_min_size = 5
    game.map_settings.enemy_expansion.settler_group_max_size = 15
    game.map_settings.enemy_expansion.min_expansion_cooldown = 60 * 3600
    game.map_settings.enemy_expansion.max_expansion_cooldown = 60 * 3600
    
    game.forces["enemy"].evolution_factor = 0.6
    
    game.forces["enemy"].kill_all_units()
end)